"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = _interopRequireDefault(require("@antv/algorithm"));
var _giSdk = require("@antv/gi-sdk");
var _ahooks = require("ahooks");
var _antd = require("antd");
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
var _utils = _interopRequireDefault(require("../utils"));
var _patternEditor = _interopRequireDefault(require("./patternEditor"));
var _patternPane = _interopRequireDefault(require("./patternPane"));
var _registerMeta = require("./registerMeta");
var _resultTable = _interopRequireDefault(require("./resultTable"));
var _util = require("./util");
var _i18n = _interopRequireDefault(require("../i18n"));
require("./index.less");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * author:shiwu.wyy@antgroup.com
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var confirm = _antd.Modal.confirm;
var TabPane = _antd.Tabs.TabPane;
var GADDI = _algorithm.default.GADDI,
  breadthFirstSearch = _algorithm.default.breadthFirstSearch;
var createUuid = _utils.default.createUuid,
  clearItemsStates = _utils.default.clearItemsStates,
  fittingString = _utils.default.fittingString;
var MAX_PATTERN_NUM = 4;
var PATTERN_MATCH_MODE = 'pattern-match-lasso';
var EXTRACT_MESSAGE_KEY = 'kg-pattern-match-extract-message';
var EXTRACT_MODE_CANVAS_CLASSNAME = 'kg-pattern-match-extract-mode-canvas';
var newTabIndex = 1;
var previousSize = {
  width: 500,
  height: 500
};
var keydown = false;
var PatternMatch = function PatternMatch(_ref) {
  var style = _ref.style,
    controlledValues = _ref.controlledValues,
    onClose = _ref.onClose,
    onOpen = _ref.onOpen,
    _ref$options = _ref.options,
    options = _ref$options === void 0 ? {} : _ref$options;
  var _a;
  var onGraphEditorVisibleChange = options.onGraphEditorVisibleChange,
    onExtractModeChange = options.onExtractModeChange,
    _options$exportPatter = options.exportPattern,
    exportPattern = _options$exportPatter === void 0 ? function (content) {
      return _giSdk.common.createDownload(JSON.stringify(content), 'pattern.json');
    } : _options$exportPatter,
    exportButton = options.exportButton;
  var _useContext = (0, _giSdk.useContext)(),
    graph = _useContext.graph,
    data = _useContext.data,
    schemaData = _useContext.schemaData,
    updateHistory = _useContext.updateHistory;
  var _useState = (0, _react.useState)('1'),
    _useState2 = _slicedToArray(_useState, 2),
    activeKey = _useState2[0],
    setActiveKey = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    editorVisible = _useState4[0],
    setEditorVisible = _useState4[1];
  var _useState5 = (0, _react.useState)([]),
    _useState6 = _slicedToArray(_useState5, 2),
    result = _useState6[0],
    setResult = _useState6[1];
  var _useState7 = (0, _react.useState)([]),
    _useState8 = _slicedToArray(_useState7, 2),
    hullIds = _useState8[0],
    setHullIds = _useState8[1];
  var _useState9 = (0, _react.useState)(false),
    _useState10 = _slicedToArray(_useState9, 2),
    loading = _useState10[0],
    setLoading = _useState10[1];
  var _useState11 = (0, _react.useState)(false),
    _useState12 = _slicedToArray(_useState11, 2),
    extracting = _useState12[0],
    setExtracting = _useState12[1];
  // 数据结构 { [nodeType: string]: Set }
  var _useState13 = (0, _react.useState)({}),
    _useState14 = _slicedToArray(_useState13, 2),
    nodeProperties = _useState14[0],
    setNodeProperties = _useState14[1];
  // 数据结构 { [edgeType: string]: Set }
  var _useState15 = (0, _react.useState)({}),
    _useState16 = _slicedToArray(_useState15, 2),
    edgeProperties = _useState16[0],
    setEdgeProperties = _useState16[1];
  var _useState17 = (0, _react.useState)([]),
    _useState18 = _slicedToArray(_useState17, 2),
    nodeTypes = _useState18[0],
    setNodeTypes = _useState18[1];
  var _useState19 = (0, _react.useState)([]),
    _useState20 = _slicedToArray(_useState19, 2),
    edgeTypes = _useState20[0],
    setEdgeTypes = _useState20[1];
  var _useState21 = (0, _react.useState)({}),
    _useState22 = _slicedToArray(_useState21, 2),
    schemaEdgeMap = _useState22[0],
    setSchemaEdgeMap = _useState22[1];
  var _useState23 = (0, _react.useState)({}),
    _useState24 = _slicedToArray(_useState23, 2),
    schemaNodeMap = _useState24[0],
    setSchemaNodeMap = _useState24[1];
  var graphModeCacheRef = (0, _react.useRef)((graph === null || graph === void 0 ? void 0 : graph.getCurrentMode()) || 'default');
  var initialPatternInfoMap = (0, _react.useMemo)(function () {
    return {
      '1': {
        id: '1',
        title: _i18n.default.get({
          id: 'gi-assets-algorithm.src.PatternMatch.Component.Mode',
          dm: '模式-1'
        }),
        data: null
      }
    };
  }, []);
  var _useState25 = (0, _react.useState)(initialPatternInfoMap),
    _useState26 = _slicedToArray(_useState25, 2),
    patternInfoMap = _useState26[0],
    setPatternInfoMap = _useState26[1];
  var importData = function importData(data, patternId) {
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    newPatternInfoMap[patternId].data = data;
    setPatternInfoMap(newPatternInfoMap);
  };
  var _useState27 = (0, _react.useState)(function () {
      return [{
        title: _i18n.default.get({
          id: 'gi-assets-algorithm.src.PatternMatch.Component.ModeIntialpatterninfomapid',
          dm: '模式-{intialPatternInfoMapId}'
        }, {
          intialPatternInfoMapId: initialPatternInfoMap['1'].id
        }),
        content: /*#__PURE__*/_react.default.createElement(_patternPane.default, Object.assign({}, initialPatternInfoMap['1'], {
          schemaEdgeMap: schemaEdgeMap,
          editPattern: function editPattern() {
            return setEditorVisible(true);
          },
          importData: importData
        })),
        key: initialPatternInfoMap['1'].id
      }];
    }),
    _useState28 = _slicedToArray(_useState27, 2),
    panes = _useState28[0],
    setPanes = _useState28[1];
  (0, _react.useEffect)(function () {
    if (!graph || graph.destroyed) return;
    // init previousSize
    previousSize = {
      width: graph.getWidth(),
      height: graph.getHeight()
    };
    var handleClickEdge = function handleClickEdge(e) {
      var mode = graph.getCurrentMode();
      if (mode !== PATTERN_MATCH_MODE) return;
      // 选中边时，自动选中边的端点
      var edge = e.item;
      var source = edge.getSource();
      var target = edge.getTarget();
      graph.setItemState(source, _registerMeta.ITEM_STATE.Active, true);
      graph.setItemState(target, _registerMeta.ITEM_STATE.Active, true);
    };
    graph.on('edge:click', handleClickEdge);
    return function () {
      graph.off('edge:click', handleClickEdge);
    };
  }, []);
  (0, _react.useEffect)(function () {
    var sEdgeMap = {};
    var sNodeMap = {};
    schemaData.edges.forEach(function (schemaEdge) {
      return sEdgeMap[schemaEdge.edgeType] = schemaEdge;
    });
    schemaData.nodes.forEach(function (schemaNode) {
      return sNodeMap[schemaNode.nodeType] = schemaNode;
    });
    // 数据结构 { [nodeType: string]: Set }
    var nodeTypeProperties = {};
    data.nodes.forEach(function (node) {
      nodeTypeProperties[node.nodeType] = nodeTypeProperties[node.nodeType] || new Set();
      Object.keys(node.data).forEach(function (key) {
        return nodeTypeProperties[node.nodeType].add(key);
      });
    });
    var nTypes = Object.keys(nodeTypeProperties).map(function (key) {
      var fittedText = fittingString(key, 280, 14);
      return {
        key: key,
        text: key,
        content: /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
          title: (fittedText === null || fittedText === void 0 ? void 0 : fittedText.includes('…')) ? key : ''
        }, fittedText)
      };
    });
    // 数据结构 { [edgeType: string]: Set }
    var edgeTypeProperties = {};
    data.edges.forEach(function (edge) {
      var edgeType = edge.edgeType;
      var schema = sEdgeMap[edgeType] || {};
      var sourceNodeType = schema.sourceNodeType,
        targetNodeType = schema.targetNodeType;
      var spo = "".concat(sourceNodeType).concat(_registerMeta.SPLITOR).concat(edgeType).concat(_registerMeta.SPLITOR).concat(targetNodeType);
      edgeTypeProperties[spo] = edgeTypeProperties[spo] || new Set();
      Object.keys(edge.data).forEach(function (key) {
        return edgeTypeProperties[spo].add(key);
      });
    });
    var eTypes = Object.keys(edgeTypeProperties).map(function (key) {
      var _key$split = key.split(_registerMeta.SPLITOR),
        _key$split2 = _slicedToArray(_key$split, 3),
        sourceNodeType = _key$split2[0],
        typeName = _key$split2[1],
        targetNodeType = _key$split2[2];
      var subText = "".concat(sourceNodeType, " \u2192 ").concat(targetNodeType);
      var fittedText = fittingString(typeName, 280, 14);
      var fittedSubText = fittingString(subText, 280, 14);
      return {
        key: key,
        typeName: typeName,
        sourceNodeType: sourceNodeType,
        targetNodeType: targetNodeType,
        content: /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
          title: (fittedText === null || fittedText === void 0 ? void 0 : fittedText.includes('…')) || (fittedSubText === null || fittedSubText === void 0 ? void 0 : fittedSubText.includes('…')) ? "".concat(typeName, " (").concat(subText, ")") : ''
        }, fittedText, /*#__PURE__*/_react.default.createElement("p", {
          className: "kg-node-importance-tip"
        }, fittedSubText))
      };
    });
    setSchemaEdgeMap(sEdgeMap);
    setSchemaNodeMap(sNodeMap);
    setNodeProperties(nodeTypeProperties);
    setEdgeProperties(edgeTypeProperties);
    setNodeTypes(nTypes);
    setEdgeTypes(eTypes);
  }, [data]);
  // 编辑器的显示抛出回调
  (0, _react.useEffect)(function () {
    return onGraphEditorVisibleChange === null || onGraphEditorVisibleChange === void 0 ? void 0 : onGraphEditorVisibleChange(editorVisible);
  }, [editorVisible]);
  // 模式编辑完成后，patternInfoMap 发生变化，触发模式 tabs 中显示的内容变化
  (0, _react.useEffect)(function () {
    var newPanes = panes.map(function (pane) {
      var _a;
      return Object.assign(Object.assign({}, pane), {
        content: /*#__PURE__*/_react.default.createElement(_patternPane.default, {
          id: pane.key,
          data: (_a = patternInfoMap[pane.key]) === null || _a === void 0 ? void 0 : _a.data,
          schemaEdgeMap: schemaEdgeMap,
          editPattern: function editPattern() {
            return setEditorVisible(true);
          },
          extractPattern: enableExtractingMode,
          importData: importData
        })
      });
    });
    setPanes(newPanes);
  }, [patternInfoMap]);
  /**
   * 受控参数变化，自动进行分析
   * e.g. ChatGPT，历史记录模版等
   */
  (0, _react.useEffect)(function () {
    if (controlledValues) {
      var key = "".concat(newTabIndex + 1);
      addTab({
        key: key
      });
      savePattern(key, controlledValues.pattern);
      onMatch(controlledValues.pattern);
      onOpen === null || onOpen === void 0 ? void 0 : onOpen();
    }
  }, [controlledValues]);
  (0, _react.useEffect)(function () {
    var handleClick = function handleClick(e) {
      var item = e.item;
      graph.setItemState(item, _registerMeta.ITEM_STATE.Active, !item.hasState(_registerMeta.ITEM_STATE.Active));
    };
    if (extracting) {
      graph.on('edge:click', handleClick);
      graph.on('node:click', handleClick);
    } else {
      graph.off('edge:click', handleClick);
      graph.off('node:click', handleClick);
    }
    return function () {
      graph.off('edge:click', handleClick);
      graph.off('node:click', handleClick);
    };
  }, [extracting]);
  var enableExtractingMode = (0, _ahooks.useMemoizedFn)(function (patternId) {
    if (!graph || graph.destroyed) return;
    previousSize = {
      width: graph.getWidth(),
      height: graph.getHeight()
    };
    _antd.message.info({
      key: EXTRACT_MESSAGE_KEY,
      className: 'kg-pattern-match-extract-tip-long',
      duration: 0,
      content: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.TheCanvasIsInThe',
        dm: '画布处于选择状态，你可以通过【圈选】或【点选】子图，被选中的子图将被抽取为模式。【按住 W】 可拖拽画布'
      }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
        onClick: cancelExtracting,
        style: {
          marginLeft: 8
        },
        size: "small"
      }, _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.Cancel',
        dm: '取消'
      })), /*#__PURE__*/_react.default.createElement(_antd.Button, {
        type: "primary",
        onClick: extractPattern,
        style: {
          marginLeft: 8
        },
        size: "small"
      }, _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.Confirm',
        dm: '确认'
      }))),
      style: {
        marginTop: '20px'
      }
    });
    graph.setMode(PATTERN_MATCH_MODE); // 切换为 lasso 交互模式，该模式下没有其他 behavior
    // 恢复图上的选中状态，为拉索框选做准备
    clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Active]);
    clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Active]);
    setExtracting(patternId);
    onClose === null || onClose === void 0 ? void 0 : onClose(); // 隐藏抽屉;
    onExtractModeChange === null || onExtractModeChange === void 0 ? void 0 : onExtractModeChange(true);
    // 设置 canvas dom 描边样式
    setCanvasDomStyle(true);
  });
  var quitExtractMode = function quitExtractMode() {
    graph.setMode(graphModeCacheRef.current); // 恢复默认交互模式
    _antd.message.destroy(EXTRACT_MESSAGE_KEY); // 销毁提示 message
    setExtracting(false); // 恢复面板状态
    onOpen === null || onOpen === void 0 ? void 0 : onOpen(); // 显示抽屉
    setExtracting(false); // 恢复面板状态
    onExtractModeChange === null || onExtractModeChange === void 0 ? void 0 : onExtractModeChange(false);
    // 设置 canvas dom 描边样式
    setCanvasDomStyle(false);
  };
  var extractPattern = (0, _ahooks.useMemoizedFn)(function () {
    if (!graph || graph.destroyed) {
      quitExtractMode();
      return;
    }
    if (!extracting) return;
    var patternId = extracting;
    var selectedNodeIds = (graph.findAllByState('node', _registerMeta.ITEM_STATE.Active) || []).map(function (node) {
      return node.getID();
    });
    var selectedEdgeIds = (graph.findAllByState('edge', _registerMeta.ITEM_STATE.Active) || []).map(function (node) {
      return node.getID();
    });
    if (!selectedNodeIds.length) return;
    // 验证当前模式图是连通的
    var patternGraphData = {
      nodes: data.nodes.filter(function (node) {
        return selectedNodeIds.includes(node.id);
      }),
      edges: data.edges.filter(function (edge) {
        return selectedEdgeIds.includes(edge.id);
      })
    };
    var traversedTag = {};
    breadthFirstSearch(patternGraphData, patternGraphData.nodes[0].id, {
      enter: function enter(_ref2) {
        var current = _ref2.current;
        traversedTag[current] = true;
      }
    }, false);
    if (Object.keys(traversedTag).length < patternGraphData.nodes.length) {
      _antd.message.info(_i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.FailedToCreateTheSchema',
        dm: '创建模式失败。模式必须是连通的'
      }));
      return;
    }
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    // 抽取成模式
    var newIdMap = {};
    var pattern = {
      nodes: [],
      edges: []
    };
    patternGraphData.nodes.forEach(function (node, i) {
      var dataId = node.id,
        nodeType = node.nodeType;
      var id = createUuid();
      newIdMap[dataId] = {
        id: id,
        nodeType: nodeType
      };
      pattern.nodes.push({
        id: id,
        oriId: dataId,
        cluster: undefined,
        rules: undefined,
        nodeType: nodeType,
        style: {
          label: {
            value: "".concat(nodeType, "-").concat(pattern.nodes.length)
          }
        },
        originLabel: "".concat(nodeType, "-").concat(pattern.nodes.length),
        data: {
          id: id,
          nodeType: nodeType
        }
      });
    });
    // 抽取边的同时，验证当前模式图中所有边的端点都在 nodes 中
    var invalid = false;
    for (var i = 0; i < patternGraphData.edges.length; i++) {
      var edge = patternGraphData.edges[i];
      var dataId = edge.id,
        dataSource = edge.source,
        dataTarget = edge.target,
        edgeType = edge.edgeType;
      if (!newIdMap[dataSource] || !newIdMap[dataTarget]) {
        invalid = true;
        break;
      }
      var _newIdMap$dataSource = newIdMap[dataSource],
        source = _newIdMap$dataSource.id,
        sourceNodeType = _newIdMap$dataSource.nodeType;
      var _newIdMap$dataTarget = newIdMap[dataTarget],
        target = _newIdMap$dataTarget.id,
        targetNodeType = _newIdMap$dataTarget.nodeType;
      pattern.edges.push({
        id: "".concat(source, "-").concat(target, "-").concat(createUuid()),
        oriId: dataId,
        source: source,
        target: target,
        rules: [],
        type: source === target ? 'loop' : 'graphin-line',
        loopCfg: {
          position: 'top',
          dist: source === target ? 25 : 20
        },
        style: {
          label: {
            value: "".concat(edgeType, "-").concat(pattern.edges.length)
          }
        },
        label: "".concat(edgeType, "-").concat(pattern.edges.length),
        labelCfg: {
          autoRotate: true
        },
        edgeType: edgeType,
        sourceNodeType: sourceNodeType,
        targetNodeType: targetNodeType
      });
    }
    if (invalid) {
      _antd.message.info(_i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.FailedToCreateTheSchema.1',
        dm: '创建模式失败。模式中不可以存在悬挂边'
      }));
      return;
    }
    newPatternInfoMap[patternId].data = pattern;
    setPatternInfoMap(newPatternInfoMap); // 放入模式编辑器中
    quitExtractMode();
  });
  var cancelExtracting = function cancelExtracting() {
    setExtracting(false);
    if (!graph || graph.destroyed) return;
    // 如果有选中的内容，退出需要二次提示
    var selectedNodes = graph.findAllByState('node', _registerMeta.ITEM_STATE.Active);
    var selectedEdges = graph.findAllByState('node', _registerMeta.ITEM_STATE.Active);
    if ((selectedNodes === null || selectedNodes === void 0 ? void 0 : selectedNodes.length) || (selectedEdges === null || selectedEdges === void 0 ? void 0 : selectedEdges.length)) {
      confirm({
        title: _i18n.default.get({
          id: 'gi-assets-algorithm.src.PatternMatch.Component.ConfirmToExitTheExtraction',
          dm: '确认退出抽取模式'
        }),
        icon: /*#__PURE__*/_react.default.createElement(_icons.ExclamationCircleOutlined, null),
        content: _i18n.default.get({
          id: 'gi-assets-algorithm.src.PatternMatch.Component.IfTheSelectedContentAlready',
          dm: '已有选中内容，退出将不会将使用选中内容作为模式。确认退出吗？'
        }),
        onOk: function onOk() {
          clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Active]);
          clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Active]);
          graph.setMode(graphModeCacheRef.current);
          _antd.message.destroy(EXTRACT_MESSAGE_KEY);
          onOpen === null || onOpen === void 0 ? void 0 : onOpen(); // 显示抽屉
          quitExtractMode();
        }
      });
    } else {
      graph.setMode(graphModeCacheRef.current);
      _antd.message.destroy(EXTRACT_MESSAGE_KEY);
      onOpen === null || onOpen === void 0 ? void 0 : onOpen(); // 显示抽屉
      quitExtractMode();
    }
  };
  // 为 graph 绑定元素更新监听，更新 hulll
  var updateHull = function updateHull(e) {
    var _a, _b;
    if (!graph || graph.destroyed) return;
    var id = ((_b = (_a = e === null || e === void 0 ? void 0 : e.item) === null || _a === void 0 ? void 0 : _a.getType) === null || _b === void 0 ? void 0 : _b.call(_a)) === 'node' ? e.item.getID() : undefined;
    var hulls = graph.getHulls();
    if (!hulls) return;
    var foundHullKeys = [];
    Object.keys(hulls).forEach(function (key) {
      var _a;
      var hull = hulls[key];
      if (id === undefined) foundHullKeys.push(key);else if ((_a = hull === null || hull === void 0 ? void 0 : hull.members) === null || _a === void 0 ? void 0 : _a.find(function (node) {
        var _a;
        return ((_a = node.getID) === null || _a === void 0 ? void 0 : _a.call(node)) === id;
      })) foundHullKeys.push(key);
    });
    foundHullKeys.forEach(function (key) {
      return hulls[key].updateData(hulls[key].members, []);
    });
  };
  var removeHulls = function removeHulls() {
    setHullIds(function (ids) {
      var hullMap = graph.get('hullMap') || {};
      ids === null || ids === void 0 ? void 0 : ids.forEach(function (hullId) {
        var hull = graph.getHullById(hullId);
        if (hull) graph.removeHull(hull);
        delete hullMap[hullId];
      });
      return [];
    });
  };
  var handleKeydown = function handleKeydown(e) {
    var code = e.key;
    if (!code) return;
    if (code.toLowerCase() === 'w') keydown = true;else keydown = false;
  };
  var handleKeyup = function handleKeyup(e) {
    return keydown = false;
  };
  // tab 切换，取消图上的选中状态
  (0, _react.useEffect)(function () {
    if (graph && !graph.destroyed) {
      clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Active]);
      clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Active]);
    }
  }, [activeKey]);
  (0, _react.useEffect)(function () {
    _antd.message.destroy(EXTRACT_MESSAGE_KEY); // 销毁提示 message
    if (!graph || graph.destroyed) return;
    graph.addBehaviors([{
      type: 'lasso-select',
      trigger: 'drag',
      selectedState: _registerMeta.ITEM_STATE.Active,
      shouldDeselect: function shouldDeselect() {
        return false;
      }
    }, 'zoom-canvas', {
      type: 'drag-canvas',
      shouldBegin: function shouldBegin() {
        return keydown;
      }
    }], 'pattern-match-lasso');
    graph.on('afterupdateitem', updateHull);
    graph.on('afterlayout', updateHull);
    graph.on('graphin:datachange', removeHulls);
    graph.on('node:toggleevent', removeHulls);
    graph.on('sizechange', updateDomSize);
    graph.on('keydown', handleKeydown);
    graph.on('keyup', handleKeyup);
    return function () {
      _antd.message.destroy(EXTRACT_MESSAGE_KEY); // 销毁提示 message
      if (graph && !graph.destroyed) {
        setCanvasDomStyle(false);
        graph.off('afterudpateitem', updateHull);
        graph.off('afterlayout', updateHull);
        graph.off('graphin:datachange', removeHulls);
        graph.off('node:toggleevent', removeHulls);
        graph.off('sizechange', updateDomSize);
        graph.off('keydown', handleKeydown);
        graph.off('keyup', handleKeyup);
      }
    };
  }, []);
  /** 浏览器宽高改变时，在抽取状态下需要更新画布宽高以便显示画布外边框 */
  var updateDomSize = function updateDomSize(_ref3) {
    var width = _ref3.width,
      height = _ref3.height;
    previousSize = {
      width: width,
      height: height
    };
    var canvasDOM = graph.get('canvas').get('el');
    if (canvasDOM.classList.contains(EXTRACT_MODE_CANVAS_CLASSNAME)) {
      setTimeout(function () {
        graph.changeSize(width - 32, height - 32);
      }, 151);
    } else if (width !== graph.getWidth() || height !== graph.getHeight()) {
      graph.changeSize(width, height);
    }
  };
  var setCanvasDomStyle = function setCanvasDomStyle(extractMode) {
    var canvasDOM = graph.get('canvas').get('el');
    if (extractMode) {
      graph.changeSize(previousSize.width - 32, previousSize.height - 32);
      canvasDOM.classList.add(EXTRACT_MODE_CANVAS_CLASSNAME);
    } else {
      var _previousSize = previousSize,
        width = _previousSize.width,
        height = _previousSize.height;
      graph.changeSize(width, height);
      canvasDOM.classList.remove(EXTRACT_MODE_CANVAS_CLASSNAME);
    }
  };
  var addTab = function addTab() {
    var copyItem = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
    var _a;
    if (panes.length > MAX_PATTERN_NUM - 1) {
      _antd.message.info(_i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.FailedToAddModeThe',
        dm: '添加模式失败。模式数量已达上限！'
      }));
      return;
    }
    newTabIndex += 1;
    var id = "".concat(newTabIndex);
    var newPanes = _toConsumableArray(panes);
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    newPatternInfoMap[id] = {
      id: id,
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.ModeId',
        dm: '模式-{id}'
      }, {
        id: id
      }),
      data: null
    };
    if (copyItem && ((_a = patternInfoMap[copyItem.key]) === null || _a === void 0 ? void 0 : _a.data)) {
      newPatternInfoMap[id].data = (0, _lodash.cloneDeep)(patternInfoMap[copyItem.key].data);
    }
    newPanes.push({
      content: /*#__PURE__*/_react.default.createElement(_patternPane.default, {
        id: id,
        data: newPatternInfoMap[id],
        schemaEdgeMap: schemaEdgeMap,
        editPattern: function editPattern() {
          return setEditorVisible(true);
        },
        importData: importData
      }),
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.ModeId',
        dm: '模式-{id}'
      }, {
        id: id
      }),
      key: id
    });
    setPanes(newPanes);
    setPatternInfoMap(newPatternInfoMap);
    setActiveKey(id);
  };
  var removeTab = function removeTab(key) {
    var newActiveKey = activeKey;
    var lastIndex;
    panes.forEach(function (pane, i) {
      if (pane.key === key) {
        lastIndex = i - 1;
      }
    });
    var newPanes = panes.filter(function (pane) {
      return pane.key !== key;
    });
    if (newPanes.length && newActiveKey === key) {
      if (lastIndex >= 0) {
        newActiveKey = newPanes[lastIndex].key;
      } else {
        newActiveKey = newPanes[0].key;
      }
    }
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    delete newPatternInfoMap[key];
    setActiveKey(newActiveKey);
    setPatternInfoMap(newPatternInfoMap);
    setPanes(newPanes);
  };
  var onTabEdit = function onTabEdit(targetKey, action) {
    if (action === 'remove') removeTab(targetKey);
  };
  var drawHulls = function drawHulls(matches) {
    removeHulls();
    var ids = [];
    matches.forEach(function (match) {
      var _a;
      var hullId = createUuid();
      ids.push(hullId);
      match.hullId = hullId;
      graph.createHull({
        id: hullId,
        members: (_a = match.nodes) === null || _a === void 0 ? void 0 : _a.map(function (node) {
          return node.id;
        }),
        padding: 10
      });
    });
    setHullIds(ids);
  };
  var onMatch = function onMatch(patternProp) {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var _b, res, pattern, graphData, directed, matches;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (!(!graph || graph.destroyed)) {
              _context.next = 3;
              break;
            }
            handleUpdateHistory({}, false, _i18n.default.get({
              id: 'gi-assets-algorithm.src.PatternMatch.Component.TheGraphInstanceDoesNot',
              dm: '图实例不存在'
            }));
            return _context.abrupt("return");
          case 3:
            if (!(!patternProp && (!activeKey || !((_b = patternInfoMap[+activeKey]) === null || _b === void 0 ? void 0 : _b.data)))) {
              _context.next = 7;
              break;
            }
            _antd.message.info(_i18n.default.get({
              id: 'gi-assets-algorithm.src.PatternMatch.Component.TheNullPatternCannotBe',
              dm: '无法匹配空模式！'
            }));
            handleUpdateHistory({}, false, _i18n.default.get({
              id: 'gi-assets-algorithm.src.PatternMatch.Component.TheNullPatternCannotBe',
              dm: '无法匹配空模式！'
            }));
            return _context.abrupt("return");
          case 7:
            res = patternInfoMap[+activeKey].data;
            pattern = patternProp || {
              nodes: res.nodes.map(function (node) {
                return {
                  id: node.id,
                  label: node.nodeType,
                  name: node.nodeType,
                  rules: node.rules
                };
              }),
              edges: res.edges.map(function (edge) {
                return {
                  id: edge.id,
                  label: edge.edgeType,
                  source: edge.source,
                  target: edge.target,
                  rules: edge.rules
                };
              })
            };
            graphData = {
              nodes: [],
              edges: []
            };
            data.nodes.forEach(function (node) {
              var _a;
              if (!((_a = graph.findById(node.id)) === null || _a === void 0 ? void 0 : _a.isVisible())) return;
              graphData.nodes.push({
                id: node.id,
                data: node.data,
                label: node.nodeType
              });
            });
            data.edges.forEach(function (edge) {
              var _a;
              if (!((_a = graph.findById(edge.id)) === null || _a === void 0 ? void 0 : _a.isVisible())) return;
              graphData.edges.push({
                id: edge.id,
                data: edge.data,
                source: edge.source,
                target: edge.target,
                label: edge.edgeType
              });
            });
            // 计算模式匹配结果
            setLoading(true);
            directed = true;
            matches = [];
            _context.prev = 15;
            _context.next = 18;
            return GADDI(graphData, pattern, directed, undefined, undefined, 'label', 'label');
          case 18:
            matches = _context.sent;
            _context.next = 24;
            break;
          case 21:
            _context.prev = 21;
            _context.t0 = _context["catch"](15);
            console.warn('Pattern Matching Failed.', _context.t0);
          case 24:
            if (matches === null || matches === void 0 ? void 0 : matches.length) {
              _context.next = 31;
              break;
            }
            _antd.message.info(_i18n.default.get({
              id: 'gi-assets-algorithm.src.PatternMatch.Component.NoMatchFound',
              dm: '没有找到匹配！'
            }));
            setLoading(false);
            drawHulls([]);
            setResult([]);
            handleUpdateHistory({
              pattern: pattern
            }, false, _i18n.default.get({
              id: 'gi-assets-algorithm.src.PatternMatch.Component.NoMatchFound',
              dm: '没有找到匹配！'
            }));
            return _context.abrupt("return");
          case 31:
            // 对结果 matches 进行 rules 的筛选
            (0, _util.filterByPatternRules)(graphData, pattern, matches, directed);
            // 进行 rules 筛选之后，若 matches 被删空了，提示没找到匹配
            if (!(matches === null || matches === void 0 ? void 0 : matches.length)) {
              _antd.message.info(_i18n.default.get({
                id: 'gi-assets-algorithm.src.PatternMatch.Component.NoMatchFound',
                dm: '没有找到匹配！'
              }));
            }
            setLoading(false);
            drawHulls(matches);
            setResult(matches);
            handleUpdateHistory({
              pattern: pattern
            });
          case 37:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[15, 21]]);
    }));
  };
  var onExport = function onExport() {
    var _a;
    if (!graph || graph.destroyed) return;
    if (!activeKey || !((_a = patternInfoMap[+activeKey]) === null || _a === void 0 ? void 0 : _a.data)) {
      _antd.message.info(_i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.TheNullPatternCannotBe',
        dm: '无法匹配空模式！'
      }));
      return;
    }
    var res = patternInfoMap[+activeKey].data;
    var pattern = {
      nodes: res.nodes.map(function (node) {
        (0, _lodash.set)(node, 'data.label', node.nodeType);
        (0, _lodash.set)(node, 'data.rules', node.rules);
        return node.data;
      }),
      edges: res.edges.map(function (edge) {
        (0, _lodash.set)(edge, 'data.label', edge.edgeType);
        (0, _lodash.set)(edge, 'data.rules', edge.rules);
        return edge.data;
      })
    };
    exportPattern === null || exportPattern === void 0 ? void 0 : exportPattern(pattern);
  };
  var savePattern = function savePattern(id, saveData) {
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    if (!newPatternInfoMap[id]) {
      newPatternInfoMap[id] = {
        id: id,
        title: _i18n.default.get({
          id: 'gi-assets-algorithm.src.PatternMatch.Component.ModeId',
          dm: '模式-{id}'
        }, {
          id: id
        })
      };
    }
    newPatternInfoMap[id].data = saveData;
    setPatternInfoMap(newPatternInfoMap);
  };
  var reset = function reset() {
    clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Active]);
    clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Active]);
    removeHulls();
    setResult([]);
  };
  /**
   * 更新到历史记录
   * @param success 是否成功
   * @param errorMsg 若失败，填写失败信息
   * @param value 查询语句
   */
  var handleUpdateHistory = function handleUpdateHistory(params) {
    var success = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var errorMsg = arguments.length > 2 ? arguments[2] : undefined;
    var _a, _b;
    var pattern = params.pattern;
    if (!pattern) return;
    updateHistory({
      componentId: 'PatternMatch',
      type: 'analyse',
      subType: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.Component.PatternMatching',
        dm: '模式匹配'
      }),
      statement: "\u5B50\u56FE ".concat((_a = pattern.nodes) === null || _a === void 0 ? void 0 : _a.length, " \u4E2A\u8282\u70B9\uFF0C").concat((_b = pattern.edges) === null || _b === void 0 ? void 0 : _b.length, " \u6761\u8FB9"),
      success: success,
      errorMsg: errorMsg,
      params: {
        pattern: {
          nodes: pattern.nodes.map(function (node) {
            return Object.assign({
              nodeType: node.label || node.name
            }, node);
          }),
          edges: pattern.edges.map(function (edge) {
            return Object.assign({
              edgeType: edge.label
            }, edge);
          })
        }
      }
    });
  };
  var patternTabsMenu = /*#__PURE__*/_react.default.createElement(_antd.Menu, {
    className: "kg-pattern-match-patten-tab-dropdown"
  }, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    key: "new",
    onClick: addTab
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.Component.CreateMode',
    dm: '新建模式'
  })), panes === null || panes === void 0 ? void 0 : panes.map(function (item) {
    return /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: item.key,
      onClick: function onClick() {
        return addTab(item);
      }
    }, _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatch.Component.CopyMode',
      dm: '复制模式-'
    }), item.key);
  }));
  // 组件挂载时，获取 Canvas 的父元素，用于通过 Portal 放置额外按钮。
  var _useState29 = (0, _react.useState)(),
    _useState30 = _slicedToArray(_useState29, 2),
    extraButtonsContainer = _useState30[0],
    setExtraButtonsContainer = _useState30[1];
  (0, _react.useEffect)(function () {
    var canvasDOM = graph.get('canvas').get('el');
    var parentDOM = canvasDOM.parentNode;
    var container = document.createElement('div');
    parentDOM === null || parentDOM === void 0 ? void 0 : parentDOM.appendChild(container);
    setExtraButtonsContainer(container);
    return function () {
      var _a;
      (_a = container.parentNode) === null || _a === void 0 ? void 0 : _a.removeChild(container);
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    style: style
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-content-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-pattern-add-wrapper",
    style: {
      left: panes.length === 1 ? 79 : 106 + (panes.length - 1) * 108,
      display: panes.length > MAX_PATTERN_NUM - 1 ? 'none' : 'block'
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: patternTabsMenu,
    placement: "bottomCenter"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-pattern-add",
    onClick: addTab
  }, "+"))), /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    type: "editable-card",
    activeKey: activeKey,
    onChange: setActiveKey,
    onEdit: onTabEdit,
    hideAdd: true,
    style: {
      marginTop: panes.length > MAX_PATTERN_NUM - 1 ? '-4px' : '-40px'
    },
    items: panes.map(function (_ref4) {
      var key = _ref4.key,
        title = _ref4.title,
        content = _ref4.content;
      return {
        label: title,
        key: key,
        closable: panes.length > 1,
        children: content
      };
    })
  })), /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "button-wrapper",
    justify: "space-between"
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 6
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-apply-button",
    style: {
      display: extracting ? 'none' : 'inline-block'
    },
    type: "primary",
    loading: loading,
    onClick: function onClick() {
      return onMatch();
    }
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.Component.Match',
    dm: '匹配'
  }))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 6
  }, ((_a = patternInfoMap[+activeKey]) === null || _a === void 0 ? void 0 : _a.data) ? /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-export-button",
    style: Object.assign(Object.assign({}, (exportButton === null || exportButton === void 0 ? void 0 : exportButton.style) || {}), {
      display: extracting ? 'none' : 'inline-block'
    }),
    loading: loading,
    disabled: !!extracting,
    onClick: onExport
  }, (exportButton === null || exportButton === void 0 ? void 0 : exportButton.text) || _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.Component.ExportMode',
    dm: '导出模式'
  })) : ''), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 4,
    offset: 6
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-reset-button",
    danger: true,
    onClick: reset,
    icon: /*#__PURE__*/_react.default.createElement(_icons.DeleteOutlined, null)
  }))), (result === null || result === void 0 ? void 0 : result.length) && !extracting ? /*#__PURE__*/_react.default.createElement(_resultTable.default, {
    matches: result
  }) : '', /*#__PURE__*/_react.default.createElement(_patternEditor.default, {
    visible: editorVisible,
    patternInfo: patternInfoMap[activeKey],
    setVisible: setEditorVisible,
    savePattern: savePattern,
    nodeProperties: nodeProperties,
    edgeProperties: edgeProperties,
    nodeTypes: nodeTypes,
    edgeTypes: edgeTypes,
    schemaNodeMap: schemaNodeMap,
    schemaEdgeMap: schemaEdgeMap
  }));
};
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(PatternMatch);