import { IEdgeSchema } from '@antv/gi-sdk';
import { GraphinData } from '@antv/graphin';
import React from 'react';
import './index.less';
interface Props {
    id: string;
    data?: GraphinData | null;
    schemaEdgeMap?: {
        [key: string]: IEdgeSchema;
    };
    editPattern: (patternId: string) => void;
    extractPattern?: (patternId: string) => void;
    importData?: (data: object, patternId: string) => void;
}
declare const PatternPane: React.FC<Props>;
export default PatternPane;
