"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _graphin = require("@antv/graphin");
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var PatternGraph = function PatternGraph(props) {
  var pattern = props.pattern;
  React.useEffect(function () {
    var patternGraph = new _graphin.G6.Graph({
      container: 'gi-pattern-match-graph-container',
      width: 380,
      height: 250,
      fitView: true,
      defaultEdge: {
        size: 2,
        style: {
          endArrow: {
            path: _graphin.G6.Arrow.triangle(10, 10)
          }
        },
        labelCfg: {
          autoRotate: true,
          style: {
            stroke: '#fff',
            lineWidth: 2
          }
        }
      },
      defaultNode: {
        labelCfg: {
          position: 'right'
        }
      },
      layout: {
        type: 'dagre',
        ranksep: 20
      }
    });
    var clonePattern = JSON.parse(JSON.stringify(pattern));
    patternGraph.data(clonePattern);
    patternGraph.render();
    return function () {
      patternGraph.destroy();
    };
  }, [pattern]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    id: "gi-pattern-match-graph-container"
  }));
};
var _default = exports.default = PatternGraph;