declare const components: {
    NodesClustering: {
        info: {
            id: string;
            category: string;
            type: string;
            name: string;
            desc: string;
            icon: string;
            cover: string;
            docs: string;
        };
        component: import("react").NamedExoticComponent<import("./NodesClustering/Component").NodesClusteringProps>;
        registerMeta: (context: any) => {
            GI_CONTAINER_INDEX: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    min: number;
                    max: number;
                };
                default: number;
            };
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    ghost: boolean;
                    className: string;
                };
                properties: {
                    GIAC_CONTENT: {
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            header: string;
                        };
                        properties: {
                            visible: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            disabled: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            isShowTitle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            title: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowIcon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                            };
                            icon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowTooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            tooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipColor: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            hasDivider: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            height: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isVertical: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerType: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                enum: {
                                    label: string;
                                    value: string;
                                }[];
                                default: string;
                            };
                            containerAnimate: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerDraggable: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            dragHandle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            containerPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            offset: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: number[];
                            };
                            containerWidth: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            containerHeight: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            contaienrMask: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {};
                                default: boolean;
                            };
                        };
                    };
                };
            };
        };
    };
    NodesSimilarity: {
        info: {
            id: string;
            name: string;
            category: string;
            type: string;
            desc: string;
            cover: string;
            icon: string;
            docs: string;
        };
        component: import("react").NamedExoticComponent<import("./NodesSimilarity/Component").CommunityDiscoveryProps>;
        registerMeta: ({ schemaData }: {
            schemaData: any;
        }) => {
            GI_CONTAINER_INDEX: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    min: number;
                    max: number;
                };
                default: number;
            };
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    ghost: boolean;
                    className: string;
                };
                properties: {
                    GIAC_CONTENT: {
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            header: string;
                        };
                        properties: {
                            visible: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            disabled: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            isShowTitle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            title: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowIcon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                            };
                            icon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowTooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            tooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipColor: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            hasDivider: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            height: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isVertical: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerType: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                enum: {
                                    label: string;
                                    value: string;
                                }[];
                                default: string;
                            };
                            containerAnimate: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerDraggable: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            dragHandle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            containerPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            offset: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: number[];
                            };
                            containerWidth: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            containerHeight: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            contaienrMask: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {};
                                default: boolean;
                            };
                        };
                    };
                };
            };
            labelFormat: {
                title: string;
                type: string;
                properties: {
                    enable: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                        default: boolean;
                    };
                    mainLabel: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        enum: any[];
                        'x-component-props': {
                            mode: string;
                            allowClear: boolean;
                            showSearch: boolean;
                        };
                    };
                    subLabel: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        enum: any[];
                        'x-component-props': {
                            mode: string;
                            allowClear: boolean;
                            showSearch: boolean;
                        };
                    };
                };
            };
            nodeSelectionMode: {
                title: string;
                type: string;
                enum: {
                    value: import("@antv/gi-common-components").NodeSelectionMode;
                    label: string;
                }[];
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    mode: string;
                };
                default: import("@antv/gi-common-components").NodeSelectionMode[];
            };
            nodeLabel: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                enum: {
                    value: string;
                    label: string;
                }[];
                default: string;
                'x-component-props': {
                    showSearch: boolean;
                };
            };
        };
    };
    CommunityDetection: {
        info: {
            id: string;
            name: string;
            category: string;
            type: string;
            desc: string;
            cover: string;
            icon: string;
            docs: string;
        };
        component: import("react").NamedExoticComponent<import("./CommunityDetection/Component").CommunityDetectionProps>;
        registerMeta: (context: any) => {
            GI_CONTAINER_INDEX: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    min: number;
                    max: number;
                };
                default: number;
            };
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    ghost: boolean;
                    className: string;
                };
                properties: {
                    GIAC_CONTENT: {
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            header: string;
                        };
                        properties: {
                            visible: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            disabled: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            isShowTitle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            title: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowIcon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                            };
                            icon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowTooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            tooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipColor: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            hasDivider: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            height: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isVertical: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerType: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                enum: {
                                    label: string;
                                    value: string;
                                }[];
                                default: string;
                            };
                            containerAnimate: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerDraggable: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            dragHandle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            containerPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            offset: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: number[];
                            };
                            containerWidth: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            containerHeight: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            contaienrMask: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {};
                                default: boolean;
                            };
                        };
                    };
                };
            };
        };
    };
    NodeImportance: {
        info: {
            id: string;
            name: string;
            category: string;
            type: string;
            desc: string;
            cover: string;
            icon: string;
            docs: string;
        };
        component: import("react").NamedExoticComponent<import("./NodeImportance/registerMeta").NodeImportanceProps>;
        registerMeta: () => {
            GI_CONTAINER_INDEX: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    min: number;
                    max: number;
                };
                default: number;
            };
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    ghost: boolean;
                    className: string;
                };
                properties: {
                    GIAC_CONTENT: {
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            header: string;
                        };
                        properties: {
                            visible: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            disabled: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            isShowTitle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            title: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowIcon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                            };
                            icon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowTooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            tooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipColor: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            hasDivider: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            height: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isVertical: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerType: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                enum: {
                                    label: string;
                                    value: string;
                                }[];
                                default: string;
                            };
                            containerAnimate: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerDraggable: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            dragHandle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            containerPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            offset: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: number[];
                            };
                            containerWidth: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            containerHeight: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            contaienrMask: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {};
                                default: boolean;
                            };
                        };
                    };
                };
            };
        };
    };
    PatternMatch: {
        info: {
            id: string;
            name: string;
            category: string;
            type: string;
            desc: string;
            cover: string;
            icon: string;
            docs: string;
        };
        component: import("react").NamedExoticComponent<import("./PatternMatch/registerMeta").PatternMatchProps>;
        registerMeta: () => {
            GI_CONTAINER_INDEX: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    min: number;
                    max: number;
                };
                default: number;
            };
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    ghost: boolean;
                    className: string;
                };
                properties: {
                    GIAC_CONTENT: {
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            header: string;
                        };
                        properties: {
                            visible: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            disabled: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            isShowTitle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            title: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowIcon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                            };
                            icon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowTooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            tooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipColor: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            hasDivider: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            height: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isVertical: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerType: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                enum: {
                                    label: string;
                                    value: string;
                                }[];
                                default: string;
                            };
                            containerAnimate: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerDraggable: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            dragHandle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            containerPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            offset: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: number[];
                            };
                            containerWidth: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            containerHeight: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            contaienrMask: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {};
                                default: boolean;
                            };
                        };
                    };
                };
            };
        };
    };
    InfoDetection: {
        info: {
            id: string;
            name: string;
            desc: string;
            icon: string;
            cover: string;
            category: string;
            type: string;
            docs: string;
        };
        component: import("react").MemoExoticComponent<() => JSX.Element>;
        registerMeta: ({ schemaData }: {
            schemaData: any;
        }) => {
            GI_CONTAINER_INDEX: {
                title: string;
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    min: number;
                    max: number;
                };
                default: number;
            };
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    ghost: boolean;
                    className: string;
                };
                properties: {
                    GIAC_CONTENT: {
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            header: string;
                        };
                        properties: {
                            visible: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            disabled: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            isShowTitle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            title: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowIcon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                            };
                            icon: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isShowTooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-reactions': {
                                    target: string;
                                    fulfill: {
                                        state: {
                                            visible: string;
                                        };
                                    };
                                }[];
                                default: boolean;
                            };
                            tooltip: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipColor: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            tooltipPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            hasDivider: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            height: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            isVertical: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerType: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                enum: {
                                    label: string;
                                    value: string;
                                }[];
                                default: string;
                            };
                            containerAnimate: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            containerDraggable: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: boolean;
                            };
                            dragHandle: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            containerPlacement: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    options: {
                                        value: string;
                                        label: string;
                                    }[];
                                };
                                default: string;
                            };
                            offset: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: number[];
                            };
                            containerWidth: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            containerHeight: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                default: string;
                            };
                            contaienrMask: {
                                title: string;
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {};
                                default: boolean;
                            };
                        };
                    };
                };
            };
        };
    };
};
export { components };
